#include <bits/stdc++.h>

using namespace std;
#define int long long

struct point {
    double x, y;

    point(double xx, double yy) {
        x = xx;
        y = yy;
    }
};

point operator-(point a, point b) {
    return point(a.x - b.x, a.y - b.y);
}

double eps = 1e-6;
vector<vector<point>> trian;

double dist(point a1, point a2) {
    return sqrt((a1.x - a2.x) * (a1.x - a2.x) + (a1.y - a2.y) * (a1.y - a2.y));
}

double scal_pr(point vec1, point vec2) {
    return vec1.x * vec2.x + vec1.y * vec2.y;
}

double vec_pr(point vec1, point vec2) {
    return vec1.x * vec2.y - vec1.y * vec2.x;
}

double get_angle(point vec1, point vec2) {
    double answer = atan2(vec_pr(vec1, vec2), scal_pr(vec1, vec2));
    return answer;
}

double get_d(int id, int pos) {
    return dist(trian[id][pos], trian[id][(pos + 1) % 3]);
}

bool equals(double x, double y) {
    return abs(x - y) <= eps;
}

double angle_of_point(int id, int c) {

    return get_angle(trian[id][(c + 2) % 3] - trian[id][c], trian[id][(c + 1) % 3] - trian[id][c]);
}

double norm_angle(double ang) {
    if (ang < 0) {
        ang += M_PI * 2;
    }
    while (ang >= M_PI * 2) {
        ang -= M_PI * 2;
    }
    return ang;
}

bool check(int c, int f, int s, int th, int f_pos, int s_pos, int th_pos) {
    double d1 = get_d(c, 0);
    double d2 = get_d(c, 1);
    double d3 = get_d(c, 2);
    if (!equals(get_d(f, f_pos), d1) || !equals(get_d(s, s_pos), d2) || !equals(get_d(th, th_pos), d3)) {
        return false;
    }
//    cout << angle_of_point(f, (f_pos + 1) % 3) << endl;
    double s1 = angle_of_point(c, 0) + angle_of_point(f, (f_pos + 1) % 3) + angle_of_point(th, (th_pos) % 3);
    double s2 = angle_of_point(c, 1) + angle_of_point(s, (s_pos + 1) % 3) + angle_of_point(f, (f_pos) % 3);
    double s3 = angle_of_point(c, 2) + angle_of_point(th, (th_pos + 1) % 3) + angle_of_point(s, (s_pos) % 3);
    if (!equals(norm_angle(s1), M_PI) || !equals(norm_angle(s2), M_PI) || !equals(norm_angle(s3), M_PI)) {
        return false;
    }
    return true;
}

bool ok(int c, int f, int s, int th) {
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 3; ++j) {
            for (int k = 0; k < 3; ++k) {
                if (check(c, f, s, th, i, j, k))return true;
            }
        }
    }
    return false;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        vector<point> tr;
        for (int j = 0; j < 3; ++j) {
            int x, y;
            cin >> x >> y;
            tr.push_back(point(x, y));
        }
        trian.push_back(tr);
    }
    set<vector<int>> ans;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j)continue;
            for (int k = 0; k < n; ++k) {
                if (i == k || j == k)continue;
                for (int l = 0; l < n; ++l) {
                    if (l == k || l == j || l == i)continue;
                    if (ok(i, j, k, l)) {
                        vector<int> y = {i, j, k, l};
                        sort(y.begin(), y.end());
                        ans.insert(y);
                    }
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto x: ans) {
        for (int j = 0; j < 4; ++j) {
            cout << x[j] + 1 << " ";
        }
        cout << "\n";
    }
}
