#include <bits/stdc++.h>

using namespace std;
#define int long long
const int P = 137;
const int maxn = 1e5;
int p[maxn + 1];
int hsh[maxn + 1];
int rev_hsh[maxn + 1];
int hsh1[maxn + 1];
int rev_hsh1[maxn + 1];
int n;
int m;

int get_hash(int l, int r) {
    return ((hsh[r + 1] - hsh[l] * p[r - l + 1]));
}

int get_rev_hash(int l, int r) {
    return ((rev_hsh[l] - rev_hsh[r + 1] * p[r - l + 1]));
}

int get_hash1(int l, int r) {
    return ((hsh1[r + 1] - hsh1[l] * p[r - l + 1]) ) ;
}

int get_rev_hash1(int l, int r) {
    return ((rev_hsh1[l] - rev_hsh1[r + 1] * p[r - l + 1]) );
}

int solve(vector<int> a, vector<int> b) {
    n = a.size();
    m = b.size();
    int ans = 0;
    hsh[0] = 0;
    for (int i = 1; i <= n; ++i) {
        hsh[i] = (hsh[i - 1] * P + a[i - 1]) ;
    }
    rev_hsh[n] = 0;
    for (int i = n - 1; i >= 0; --i) {
        rev_hsh[i] = (rev_hsh[i + 1] * P + a[i]) ;
    }
    hsh1[0] = 0;
    for (int i = 1; i <= m; ++i) {
        hsh1[i] = (hsh1[i - 1] * P + b[i - 1]) ;
    }
    rev_hsh1[m] = 0;
    for (int i = m - 1; i >= 0; --i) {
        rev_hsh1[i] = (rev_hsh1[i + 1] * P + b[i]) ;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
//            if(clock() > CLOCKS_PER_SEC * 0.99){
//                return ans;
//            }
            int l = 0;
            int r = min(min(i + 1, n - i), min(j + 1, m - j)) + 1;
            while (l + 1 != r) {
                int mid = (l + r) / 2;
                if ((get_hash(i - mid + 1, i) + get_hash1(j - mid + 1, j))  == (get_rev_hash(i, i + mid - 1) +
                                                                                     get_rev_hash1(j, j + mid - 1)) ) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            ans = max(ans, l * 2 - 1);
            if(i == n - 1 || j == m - 1)continue;
            l = 0;
            r = min(min(i + 1, n - i), min(j + 1, m - j)) + 1;
            while (l + 1 != r) {
                int mid = (l + r) / 2;
                if ((get_hash(i - mid + 1, i) + get_hash1(j - mid + 1, j))  == (get_rev_hash(i + 1, i + mid) +
                                                                                     get_rev_hash1(j + 1, j + mid))) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            ans = max(ans, l * 2);
        }
    }
    return ans;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    p[0] = 1;
    for (int i = 1; i <= maxn; ++i) {
        p[i] = p[i - 1] * P;
    }
    int N, M;
    cin >> N >> M;
    vector<int> a(N);
    vector<int> b(M);
    for (int i = 0; i < N; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < M; ++i) {
        cin >> b[i];
    }
    cout << solve(a, b);
}
