#include <bits/stdc++.h>

using namespace std;
#define int long long
const int P = 137;
const int mod = 1e9 + 13;
const int maxn = 1e5;
int p[maxn + 1];
int hsh[maxn + 1];
int rev_hsh[maxn + 1];
int n;

int get_hash(int l, int r) {
    return ((hsh[r + 1] - hsh[l] * p[r - l + 1]) % mod + mod) % mod;
}

int get_rev_hash(int l, int r) {
    return ((rev_hsh[l] - rev_hsh[r + 1] * p[r - l + 1]) % mod + mod) % mod;
}

int get_mx_pal(vector<int> a) {
    n = a.size();
    vector<int> d1(n);
    vector<int> d2(n);
    int ans = 0;
    hsh[0] = 0;
    for (int i = 1; i <= n; ++i) {
        hsh[i] = (hsh[i - 1] * P + a[i - 1]) % mod;
    }
    rev_hsh[n] = 0;
    for (int i = n - 1; i >= 0; --i) {
        rev_hsh[i] = (rev_hsh[i + 1] * P + a[i]) % mod;
    }
    for (int i = 0; i < n; ++i) {
        int l = 0;
        int r = min(i + 1, n - i) + 1;
        while (l + 1 != r) {
            int mid = (l + r) / 2;
            if (get_hash(i - mid + 1, i) == get_rev_hash(i, i + mid - 1)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        d1[i] = l;
        ans = max(ans, d1[i] * 2 - 1);
    }
    for (int i = 0; i < n - 1; ++i) {
        int l = 0;
        int r = min(i + 1, n - i - 1) + 1;
        while (l + 1 != r) {
            int mid = (l + r) / 2;
            if (get_hash(i - mid + 1, i) == get_rev_hash(i + 1, i + mid)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        d2[i] = l;
        ans = max(ans, d2[i] * 2);
    }
    return ans;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    p[0] = 1;
    for (int i = 1; i <= maxn; ++i) {
        p[i] = p[i - 1] * P % mod;
    }

    int N, M;
    cin >> N >> M;
    vector<int> a(N);
    vector<int> b(M);
    for (int i = 0; i < N; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < M; ++i) {
        cin >> b[i];
    }
    if (N <= 500 && M <= (int) 1e5) {
        int ans = 0;
        int k = min(N, M);
        for (int i = 0; i <= k; ++i) {
            vector<int> s(min(M, N - i));
            for (int j = 0; j < s.size(); ++j) {
                s[j] = b[j] + a[j + i];
            }
            ans = max(get_mx_pal(s), ans);
        }
        for (int i = 0; i <= k; ++i) {
            vector<int> s(min(M - i, N));
            for (int j = 0; j < s.size(); ++j) {
                s[j] = b[j + i] + a[j];
            }
            ans = max(ans, get_mx_pal(s));
        }
        cout << ans << "\n";
    } else {
        cout << min(M, get_mx_pal(a));
    }
}